#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector<vector<ll>> g;
vector<ll> sa;
set<ll> w;
void dfs(ll v, ll st) {
    sa[v] = 1;
    w.insert(v);
    for (ll x : g[v]) {
        if (st && w.find(x) == w.end()) {
            dfs(x, st - 1);
        }
    }
}
void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    g.resize(n), sa.resize(n);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    for (ll i = 0; i < k; i++) {
        ll p, h;
        cin >> p >> h;
        dfs(p - 1, h);
        w.clear();
    }
    vector<ll> res;
    for (ll i = 0; i < n; i++) {
        if (sa[i]) {
            res.push_back(i + 1);
        }
    }
    cout << res.size() << endl;
    for (ll aj : res) cout << aj << ' ';
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    ll ts = 1;
    while (ts--) {
        solve();
    }
    return 0;
}